NGCM Summer Academy 2016 - Intermediate Python
==============================================

Material in this repository is created for the purpose of teaching Python programming concepts to extend that of the [Software Carpentry style basics course](https://github.com/softwaresaved/NGCMGSoton-2015-06-21), such as

* Basics refresher
	- Lists, For loops, functions, Numpy, Matplotlib
* Tuples
* Dictionaries
* Object-oriented programming (OOP)

These topics should prepare the reader for the [Summer Academy IPython course](https://github.com/jupyter/ngcm-tutorial) having already participated in a similar SWC-style basics course. 

The concepts of OOP are often covered lightly in undergraduate and basics courses. Despite this, Large amounts of scientific Python packages are written in an object oriented manner. The skills learned in this workshop should therefore enable scientists to write (and more importantly, read) the packages they are using, and also serve as a starting platform for those wanting to learn more advanced OOP languages such as C++ or Java.


Software Requirements
---------------------
Setup instructions for a range of users are available [here](http://ngcm.github.io/summer-academy-2016-basics/indexpages/prerequisites.html)

Getting Started
---------------
Teaching material is largely in Jupyter Notebook format, and can be followed by either:

1. Downloading the material from [GitHub](https://github.com/ngcm/summer-academy-2016-basics/archive/exercises_b.zip),

  navigating the main directory with

  > `cd basics_B/Intermediate_Python`

  and viewing the 'index.ipynb' as a jupyter notebook with

  > `jupyter notebook index.ipynb`

  You should also remove output with

  > `Kernel > Restart > Clear all outputs and restart`

2. Viewing static material at [nbviewer](http://nbviewer.jupyter.org/github/ngcm/summer-academy-2016-basics/blob/gh-pages/basics_B/Intermediate_Python/index.ipynb)

